<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/02/2016 *
 * ===================                          Last change: 04/02/2016 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : server_name_filter.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Filters for ext-server_name                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Filter fuer ext-server_name                      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2016 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Filter for redirecting on wrong server name (e.g. bad.your-server.tld will be redirected to your-server.tld)
function FILTER_REDIRECT_WRONG_SERVER_NAME ($filterData) {
	// Get URL
	$url = getUrl();

	// Is the configured URL same as SERVER_NAME?
	if (extractHostnameFromUrl($url) != detectServerName()) {
		// Log all attempts
		logWrongServerNameRedirect();

		// Then redirect to configured URL
		redirectToRequestUri();
	} // END - if

	// Return filter data
	return $filterData;
}

// Filter for purging old SERVER_NAME entries
function FILTER_SERVER_NAME_EXTRA_AUTOPURGE ($filterData) {
	// Is purging configured?
	if ((isApServerNameEnabled()) && (getApServerNameSince() > 0)) {
		// Then start purging
		sqlQuery('DELETE LOW_PRIORITY FROM
	`{?_MYSQL_PREFIX?}_server_name_log`
WHERE
	(UNIX_TIMESTAMP() - UNIX_TIMESTAMP(`server_name_added`)) >= {?ap_server_name_since?}',
			__FILE__, __LINE__);

		// Are some entries deleted?
		if (sqlAffectedRows() > 0) {
			// Okay, then send an email to the admin
			sendAdminNotification('{--ADMIN_PURGE_SERVER_NAME_LOG_SUBJECT--}', 'admin_purge_user_server_name_log', sqlAffectedRows());
		} // END - if
	} // END - if

	// Return filter data
	return $filterData;
}

// [EOF]
?>
